<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~lib_registration.js" 
	styles="path.css,~../css/reggie-2.css"
	>
<style>
.date-col
{
	width: 12em;
}

.operator-col input
{
	width: 95%;
}

</style>

</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="MIPs library registration" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select MIPs work plate</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">MIPs plate</td>
				<td class="input">
					<select class="required" name="bioplate" id="bioplate"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help">
					<span id="bioplate.message" class="message"></span>
					Select an existing work plate. The list contain all plates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Outcome</td>
				<td class="input">
					<label><input type="radio" name="outcome" id="outcomeSuccess" 
						checked>Success</label> - continue processing<br>
						
					<label><input type="radio" name="outcome" id="outcomeFailed" 
						>Failure</label> - no further processing
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Failure</b> option if further processing to pooled libraries is not possible.
					Existing DNA will be flagged and added to the <b>Flagged DNA</b> list.
				</td>
			</tr>
			</table>
		</div>
	</div>	
	
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Full plate registration</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Step</td>
				<td class="date-col"><b>Date</b></td>
				<td class="operator-col"><b>Operator</b></td>
				<td class="status"></td>
				<td class="help" rowspan="3">
					Enter date and operator for each step of the MIPs library preparation.
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			
			<tbody>
			<tr>
				<td class="subprompt">Hybridization</td>
				<td class="date-col">
					<input type="text" name="hybridizationDate" id="hybridizationDate"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="hybridizationOperator"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="hybridizationDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="hybridizationDate"
							data-date-format="yyyyMMdd"
							data-title="Hybridization date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="operator-col">
					<input type="text" name="hybridizationOperator" id="hybridizationOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="pcrDate"
						value="<%=HTML.encodeTags(user.getName())%>" maxlength="255">
				</td>
				<td class="status" id="hybridizationDate.status"></td>
				<td class="help">
					<span id="hybridizationDate.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt">PCR</td>
				<td class="date-col">
					<input type="text" name="pcrDate" id="pcrDate"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="pcrOperator"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="pcrDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="pcrDate"
							data-date-format="yyyyMMdd"
							data-title="PCR date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="operator-col">
					<input type="text" name="pcrOperator" id="pcrOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="cleanupDate"
						value="<%=HTML.encodeTags(user.getName())%>" maxlength="255">
				</td>
				<td class="status" id="pcrDate.status"></td>
				<td class="help">
					<span id="pcrDate.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt">Cleanup</td>
				<td class="date-col">
					<input type="text" name="cleanupDate" id="cleanupDate"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="cleanupOperator"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="cleanupDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="cleanupDate"
							data-date-format="yyyyMMdd"
							data-title="Cleanup date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="operator-col">
					<input type="text" name="cleanupOperator" id="cleanupOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="barcodeTemplate"
						value="<%=HTML.encodeTags(user.getName())%>" maxlength="255">
				</td>
				<td class="status" id="cleanupDate.status"></td>
				<td class="help">
					<span id="cleanupDate.message" class="message"></span>
				</td>
			</tr>
			</tbody>
				
			<tr>
				<td class="prompt">Barcode template</td>
				<td class="input" colspan="2">
					<select name="barcodeTemplate" id="barcodeTemplate" 
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="libProtocol"
						></select>
				</td>
				<td class="status" id="barcodeTemplate.status"></td>
				<td class="help">
					<span id="barcodeTemplate.message" class="message"></span>
					Select barcode layout template that was used to assign barcodes to the libraries.
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td class="input" colspan="2">
					<select name="libProtocol" id="libProtocol" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="libComments"
						></select>
				</td>
				<td class="status" id="libProtocol.status"></td>
				<td class="help">
					<span id="libProtocol.message" class="message"></span>
					Select the protocol used for library preparation.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Comments</td>
				<td class="input" colspan="2">
					<textarea rows="4" name="libComments" id="libComments"></textarea>
				</td>
				<td class="status" id="libComments.status"></td>
				<td class="help">
					<span id="libComments.message" class="message"></span>
					Comments about the library preparation.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>

	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>