<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");

DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~map-external-data.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>
#preview
{
	white-space: pre;
	font-size: 90%;
	color: #444444;
	background-color: #f0f0f0;
	overflow: hidden;
	min-height: 5em;
	/* Sizing settings that aims to make it align more or less to the file field */
	width: 33rem; 
	border-width: 1px;
	border-radius: 4px;
	padding: 3px 0.5em;
	margin: 0 0 0.5em 1px;
	box-sizing: content-box;
}

#more-lines
{
	border-top-width: 1px;
	border-top-style: dotted;
	color: #000000;
	margin-top: 0.25em;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Map external data to releases" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select a source data file</div>
		<div class="step-content">
			
			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">File</td>
				<td class="input">
					<input type="file" name="file" id="file" class="required" style="width: 95%;" accept=".csv,.tsv">
				</td>
				<td class="status" id="file.status"></td>
				<td class="help" rowspan="2"><span id="file.message" class="message"></span>
					<ul>
					<li>Select a tab-separated text file in UTF-8 encoding. 
					<li>The first line should contain column headers.
					<li>The first column should contain the personal number, or a release id value as specified by the <b>Map from</b> option.
					<li>The wizard will replace the first column with the value or values specified by the <b>Map to</b> option.
					<li>If no matching patient can be found the line is skipped.
					</ul>
				</td>
			</tr>
			<tr class="align-top">
				<td class="subprompt">preview</td>
				<td>
					<div id="preview"><i>No file loaded...</i></div>
				</td>
				<td></td>
			</tr>
			<tr>
				<td class="prompt">Map from</td>
				<td class="input">
					<select name="mapFrom" id="mapFrom">
						<option value="PersonalNo">Personal number
						<option value="PAD">PAD
						<option value="PatientId">Patient release ID
						<option value="CaseId">Case release ID
						<option value="SpecimenId">Specimen release ID
					</select>
				</td>
				<td class="status" id="mapFrom.status"></td>
				<td class="help"><span id="mapFrom.message" class="message"></span>
					Select the kind of values that are found in the first column.
				</td>
			</tr>
			<tr>
				<td class="prompt">Map to</td>
				<td class="input" style="padding-top: 4px; padding-bottom: 4px;">
					<div id="exportPersonalNo" style="display: none;"><input type="checkbox" checked disabled>Personal number</div>
					<div id="alsoExportPad" style="display: none;"><label><input type="checkbox" name="exportPad" id="exportPad">PAD</label></div>
					<div id="exportPatientId" style="display: none;"><input type="checkbox" checked disabled>Patient release ID</div>
					<div id="alsoExportCaseId" style="display: none;"><label><input type="checkbox" name="exportCaseId" id="exportCaseId">Case release ID</label></div>
					<div id="alsoExportSpecimenId" style="display: none;"><label><input type="checkbox" name="exportSpecimenId" id="exportSpecimenId">Specimen release ID</label></div>
				</td>
				<td class="status" id="mapTo.status"></td>
				<td class="help"><span id="mapTo.message" class="message"></span>
					Select the kind of values that should be outputted in the first column and, optionally, in extra columns.
				</td>
			</tr>
			<tr>
				<td class="prompt">Output order</td>
				<td class="input" style="padding-top: 4px; padding-bottom: 4px;">
					<label><input type="radio" name="outputOrder" id="sortOutputOrder" checked>Sort by first column</label><br>
					<label><input type="radio" name="outputOrder" id="keepOutputOrder">Same as input file</label>
				</td>
				<td class="status" id="outputOrder.status"></td>
				<td class="help"><span id="outputOrder.message" class="message"></span>
					Select if the output file should be sorted by the value in the first column
					or keep the same order as the input file.
				</td>
			</tr>
			</table>
		</div>
	</div>

	<div id="wizard-status"></div>
	<div id="wizard-progress"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="goexport" title="Export" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td><base:button id="godownload" title="Download" image="<%=home+"/images/download.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>