var RetractionProtocol = function()
{
	var rp = {};
	var debug = 0;
	
	// Page initialization
	rp.initPage = function()
	{
		Buttons.addClickHandler('print-button', Wizard.goPrint);
		var url = '../Retraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetProtocolInfo';
		url += '&caseName=' + encodeURIComponent(Data.get('page-data', 'casename'));
		url += '&patientId=' + encodeURIComponent(Data.get('page-data', 'patient-id'));
		Wizard.showLoadingAnimation('Creating protocol...');
		Wizard.asyncJsonRequest(url, rp.initializeProtocol);
	}

	rp.initializeProtocol = function(response)
	{
		var frm = document.forms['reggie'];

		var patientInfo = response.patient;

		// Patient and case info
		var patientName = patientInfo ? patientInfo.name : 'No patient information is registered for this case.';
		Doc.element('patient').innerHTML = Strings.encodeTags(patientName);
		Doc.element('allcases').innerHTML = Strings.encodeTags(response.allCaseNames.join(', '));

		// Item data
		var html = '';
		html += rp.tableRowsForItems('Specimen', response.specimen);
		html += rp.tableRowsForItems('Lysate', response.lysate);
		html += rp.tableRowsForItems('RNA', response.rna);
		html += rp.tableRowsForItems('DNA', response.dna);
		html += rp.tableRowsForItems('FlowThrough', response.flowThrough);
		html += rp.tableRowsForItems('BloodDNA', response.bloodDna);
		Doc.element('itemList').innerHTML = html;
		
		Doc.show('all-protocol');
	}
	
	rp.tableRowsForItems = function(itemType, items)
	{
		if (!items || items.length == 0) return '';
		// Table item row
		var html = '';
		for (var itemNo = 0; itemNo < items.length; itemNo++)
		{
			var item = items[itemNo];
			var isDestroyed = item.RetractStatus == 'Destroyed';
			
			html += '<tr class="'+(isDestroyed ? 'destroyed' : '')+'">';
			html += '<td>'+itemType+'</td>';
			html += '<td>'+Strings.encodeTags(item.name)+'</td>';
			html += '<td>'+rp.asBoxPosition(item.bioWell)+'</td>';
			html += '<td>'+rp.asFreezerLocation(item.bioWell)+'</td>';
			if (isDestroyed)
			{
				html += '<td>Already destroyed</td>';
			}
			else
			{
				html += '<td><div class="colorbox"></div>Destroyed</td>';
			}
			html += '</tr>';
		}
		return html;
	}

	// A biowell as plate name
	rp.asBoxPosition = function(well)
	{
		if (!well) return '';
		var plate = well.bioPlate;
		return Strings.encodeTags(plate.name + ' ' + well.location);
	}

	// A biowell as the location
	rp.asFreezerLocation = function(well)
	{
		if (!well) return '<i>- unknown -</i>';
		var storage = well.bioPlate.storage;
		if (!storage) return '<i>- unknown -</i>';
		
		var location = [];
		if (storage.name) location[location.length] = storage.name;
		if (storage.section) location[location.length] = 'Section ' +storage.section;
		if (storage.tray) location[location.length] = 'Tray ' +storage.tray;
		if (storage.position) location[location.length] = 'Position ' +storage.position;
		
		return location.join(', ');
	}

	return rp;
}();

Doc.onLoad(RetractionProtocol.initPage);

